#!/bin/bash
paramsize=$1
echo "
/* The Implementation of the Cilk-5 Multithreaded Language
 * M. Frigo, C. E. Leiserson, K. H. Randall
 * PLDI'98 
 */
#include <pthread.h>

typedef int lock_t;

#define FAILURE 0
#define SUCCESS 1
volatile int sum1, sum2, 
"
for((i=1;i<${paramsize};i++));
do
	echo -n "x$i,y$i,"
done
echo "x${paramsize},y${paramsize};
  "
  echo "

#define ROUNDS 2
#define capacity 10

void fence() {asm(\"sync\");}
volatile lock_t L = 0;
void lock() { 
// fence();
  __CPROVER_atomic_begin();
  __CPROVER_assume(L==0); 
  L=1; 
  __CPROVER_atomic_end();
  fence();
}
void unlock() {
fence();
  __CPROVER_atomic_begin(); 
  __CPROVER_assume(L==1); 
  L=0; 
  __CPROVER_atomic_end();
  // fence();
}

int counter = 0;

volatile int T = capacity/2;
volatile int H = capacity/2;

void push() 
{
  __CPROVER_atomic_begin();
  T++;
  counter++;
  __CPROVER_atomic_end();
}

int pop()
{
  T--;
 // fence(); 
 if(H>T)
  {
    T++;
    lock();
    T--;
    if(H>T)
    {
      T++;
      unlock();
      return FAILURE;
    }
    unlock();
  }
  __CPROVER_atomic_begin();
  if(counter) counter--;
  __CPROVER_atomic_end();
  return SUCCESS;
}

int steal()
{
  lock();
  H++;
  //fence();
  if(H>T)
  {
    H--;
    unlock();
    return FAILURE;
  }
  unlock();
  __CPROVER_atomic_begin();
  if(counter)counter--;
  __CPROVER_atomic_end();
  return SUCCESS;
}

void* owner(void * arg)
{
  int i;
  "
for ((i=1;i<=${paramsize};i++));
do
echo  "
  y$i=1;
  sum2+=x$i; "
done
echo "
for(i=0; i<ROUNDS; ++i)
  {
    if(nondet())
    {
      pop();
    }
    else
    {
      push();
    }
  }
}

void* thief(void * arg)
{
  int i;
  "
for((i=1;i<=$paramsize;i++));
do
	echo  "
  x$i=1;
  sum1+=y$i; "

done
echo "

for(i=0; i<ROUNDS; ++i)
  {
    steal();
  }
}

int main()
{
  pthread_t pt;
  pthread_create(&pt, 0, owner, 0);
  thief(0);
  pthread_join(pt, 0);
  assert(counter== (T-H));
  return 0;
}
"
