STARTTIME=`date`
TIMEOUT=10m
EXEC=cbmc
declare -A p2unwind=(["dekker"]=2 ["peterson"]=2 ["szymanski"]=2 ["dijkstra"]=2 ["lamport"]=2 ["Chase_Lev_Yahav"]=3 ["Cilk_WSQ"]=3)
declare -a repairtype
repairtype=(tso pso)
paramsize=40
k1size=40
#
rm -f *.to
for benchmark in "${!p2unwind[@]}"
do
	for rtype in "${repairtype[@]}"
	do
LOGTE=time-${benchmark}-${rtype}-te.log
LOGNOP=time-${benchmark}-${rtype}-nop.log
	for((i=2;i<=${paramsize};i+=2));
	do
	  sh ${benchmark}-gen.sh $i > ${benchmark}-${i}.c
	  #run trace enumeration algorithm
    	if [ ! -e ${benchmark}-${rtype}-te.to ]; then
	  echo "${i} ${benchmark}-${i}.c ${rtype} te" >> ${LOGTE}
{ time -p timeout -s 9  ${TIMEOUT} ${EXEC} --repair ${rtype}:sc --unwind ${p2unwind[$benchmark]} --no-unwinding-assertions --no-reorder-optimization --trace-enum ${benchmark}-${i}.c > ${benchmark}-${rtype}-te-${i}.log  || { touch ${benchmark}-${rtype}-te.to && echo "${i} Process Timeout " >> ${LOGTE} ; } ; } 2>> ${LOGTE}
	fi
	#run fence insertion algorithm
    	if [ ! -e ${benchmark}-${rtype}-nop.to ]; then
	  echo "${i} ${benchmark}-${i}.c ${rtype} nop" >> ${LOGNOP}
{ time -p timeout -s 9  ${TIMEOUT} ${EXEC} --repair ${rtype}:sc --unwind ${p2unwind[$benchmark]} --no-unwinding-assertions --no-reorder-optimization ${benchmark}-${i}.c > ${benchmark}-${rtype}-nop-${i}.log  || { touch ${benchmark}-${rtype}-nop.to && echo " ${i} Process Timeout " >> ${LOGNOP} ; } ; } 2>> ${LOGNOP}
	fi
	done
	done
done
#
#
#
rm -f *.to
PROGRESSLOG=progress.log
	for((j=2;j<=${k1size};j++));
	do
for benchmark in "${!p2unwind[@]}"
do
	for rtype in "${repairtype[@]}"
	do
rm -f *.to
LOGNOET=time-${benchmark}-${rtype}-${j}-noet.log
LOGET=time-${benchmark}-${rtype}-${j}-et.log
echo "Starting a new run at ${STARTTIME}" >> ${LOGNOET}
echo "Starting a new run at ${STARTTIME}" >> ${LOGET}
	for((i=2;i<=${paramsize};i+=2));
	do
	if [ ! -e ${benchmark}-${i}.c ]; then
	  sh ${benchmark}-gen.sh $i > ${benchmark}-${i}.c
	fi
	#run robmc
    	if [ ! -e ${benchmark}-${rtype}-noet.to ]; then
echo -n "Starting ${benchmark} ${rtype} with minbound ${j} and paramsize ${i} noet at `date`....." >> ${PROGRESSLOG}
	  echo "${i} ${benchmark}-${i}.c ${rtype} noet" >> ${LOGNOET}
{ time -p timeout -s 9  ${TIMEOUT} ${EXEC} --repair ${rtype}:sc --unwind ${p2unwind[$benchmark]} --no-unwinding-assertions --minbound ${j}  --no-early-termination ${benchmark}-${i}.c > ${benchmark}-${rtype}-${j}-noet-${i}.log  || { touch ${benchmark}-${rtype}-noet.to && echo " ${i} Process Timeout " >> ${LOGNOET} ; } ; } 2>> ${LOGNOET}
echo "done" >> ${PROGRESSLOG}
	fi
	#run robmc-et 
    	if [ ! -e ${benchmark}-${rtype}-et.to ]; then
echo -n "Starting ${benchmark} ${rtype} with minbound ${j} and paramsize ${i} et at `date`....." >> ${PROGRESSLOG}
	  echo "${i} ${benchmark}-${i}.c  ${rtype} et" >> ${LOGET}
{ time -p timeout -s 9  ${TIMEOUT} ${EXEC} --repair ${rtype}:sc --unwind ${p2unwind[$benchmark]} --no-unwinding-assertions --minbound ${j} ${benchmark}-${i}.c > ${benchmark}-${rtype}-${j}-et-${i}.log  || { touch ${benchmark}-${rtype}-et.to && echo " ${i} Process Timeout " >> ${LOGET} ; } ; } 2>> ${LOGET}
echo "done" >> ${PROGRESSLOG}
	fi
done
	done
	done
done



